<?php
/*
Plugin Name: Main categories
Plugin URI: http://rudd-o.com/
Description: Provides a template function to display main categories and a management interface for them
Version: 0.0.1
Author: Rudd-O
Author URI: http://rudd-o.com/

derivative work of Scott Merrill
copyright (c) 2005 Scott Merrill (skippy@skippy.net) and Manuel Amador (rudd-o@rudd-o.com)
Released under the terms of the GNU GPL
*/

function wp_list_main_cats($args = '') {

	global $wpdb;
	$exclusions = " ";
	$maincats = main_categories();
	$allcats = $wpdb->get_results("SELECT cat_ID FROM $wpdb->categories;");
	foreach ($allcats as $cat) {
		if (!$maincats[$cat->cat_ID]) $exclusions .= "{$cat->cat_ID} ";
	}

	if ($args) $args .= "&";
	$args .= "exclude=$exclusions";

	return wp_list_cats($args);

}

function wp_list_secondary_cats($args = '') {

	global $wpdb;
	$exclusions = " ";
	$maincats = main_categories();
	$allcats = $wpdb->get_results("SELECT cat_ID FROM $wpdb->categories;");
	foreach ($allcats as $cat) {
		if ($maincats[$cat->cat_ID]) $exclusions .= "{$cat->cat_ID} ";
	}

	if ($args) $args .= "&";
	$args .= "exclude=$exclusions";

	return wp_list_cats($args);

}


function main_categories() {
	$option = get_settings('maincats');
	if (!$option) $option = array();
	return $option;
}

function post_has_main_category() { /* returns the cat name (or none) */
	global $post,$wpdb;
	$cats = $wpdb->get_col("SELECT category_id FROM $wpdb->post2cat WHERE post_id = $post->ID");
	if (!$cats) {
		return false;
	}
	foreach ($cats as $cat) {
		if (category_is_main($cat)) {
			return true;
		}
	}
	return false;
}

function category_is_main($id) {
	if (!is_numeric($id)) return;
	$id = intval($id);
	$option = main_categories();
	return array_key_exists($id,$option) && $option[$id];
}

function main_cats_add_category($id) {
	if (!is_numeric($id)) return;
	$id = intval($id);
	$option = main_categories();
	$option[$id] = true;
	update_option("maincats",$option);
}

function main_cats_remove_category($id) {
	if (!is_numeric($id)) return;
	$id = intval($id);
	$option = main_categories();
	$option[$id] = false;
	update_option("maincats",$option);
}

function main_cats_admin_js() {
if (strstr($_SERVER["SCRIPT_NAME"],"categories.php") === false) return;
if ( !current_user_can('manage_categories') ) return;
?>
<script type="text/javascript" language="javascript">

function isMainCat(t) {
	var maincats_array = new Array (<?php
		$cats = main_categories();
		foreach ($cats as $key=>$in) { if ($in) print "'" . $key . "'" . ","; }
		print "'-1'";
	?>);
	var i; for (i = 0; i < maincats_array.length; i++) {
		if (t == maincats_array[i]) return true;
	} return false;
}

function mainCatsToggle(id) {
// 	alert(id);
	var checkbox = document.getElementById('maincats-'+id.toString());
	if (!checkbox) return
	if (!checkbox.checked) {
		window.location = "edit.php?page=wp-list-main-cats/wp-list-main-cats-ajax.php&removecat="+id.toString();
	} else {
		window.location = "edit.php?page=wp-list-main-cats/wp-list-main-cats-ajax.php&addcat="+id.toString();
	}
}

function addMainCatsColumn(table) {
	var rows = table.getElementsByTagName('tr');
	if (rows.length < 1) return;
	var heading = document.createElement('th');
	heading.appendChild(document.createTextNode('Main'));
	rows.item(0).appendChild(heading);
	var i;
	for (i = 1; i < rows.length; i++) {
		var item = rows.item(i);
		var tdid = item.firstChild.firstChild.nodeValue;
		var node = document.createElement('td');
		var tinput = document.createElement('input');
		tinput.setAttribute('id','maincats-'+tdid);
		if (isMainCat(tdid)) tinput.checked = true;
		tinput.setAttribute('onclick','mainCatsToggle(' + tdid + ');');
		node.setAttribute("align","center");
		tinput.setAttribute("type","checkbox");
		node.appendChild(tinput);
		item.appendChild(node);
	}
}

var t = document.getElementById('the-list-x'); if (t) addMainCatsColumn(t);
</script>
<?php
}

add_action("admin_footer","main_cats_admin_js");
?>